#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mp3info.h"

void
usage (void) 
{
  
printf ("mp3stat   version %s \n", VERSION);
  
printf ("Usage:\nmp3stat (options) \n	-h/-H/--help");
  
printf ("	            This help screen\n	-v/-V/-");
  
printf ("-version	            Display version\n    ");
  
printf ("    -b/-B/--batch <filenames> \n");

}


int
main (int argc, char *argv[]) 
{
  
int                index = 0;
  
struct statistic   mp3info;
  
static char       *kbit_array[19] = 
    { "32kbit", "40kbit", "48kbit", "56kbit", "64kbit", "80kbit",
    
"96kbit", "112kbit", "128kbit", "160kbit", "192kbit", "224kbit",
    
"256kbit", 
"288kbit",
    "320kbit", "352kbit", "384kbit", "416kbit", "448kbit" 
  };
  
int                first = -1;
  
int                last = -1;
  
int                a;

  
if (argc >= 2) {
    
if (strcmp (argv[1], "-h") == 0 || strcmp (argv[1], "-H") == 0 
	 ||strcmp (argv[1], "--help") == 0) {
      
usage ();
      
exit (0);
    
}
    
if (strcmp (argv[1], "-v") == 0 || strcmp (argv[1], "-V") == 0 
	 ||strcmp (argv[1], "--version") == 0) {
      
printf ("mp3stat %s\n", VERSION);
      
exit (0);
    
}
    
if (strcmp (argv[1], "-b") == 0 || strcmp (argv[1], "-B") == 0 
	 ||strcmp (argv[1], "--batch") == 0) {
      
for (index = 2; index <= argc - 1; index++) {
	
mp3info.name = argv[index];
	
if (get_file_data (&mp3info) == 0) {
	  
printf ("%s:\n", mp3info.name);
	  
printf ("  Average bit rate: %.2f kbps\n",
		   mp3info.average_bitrate / 1000);
	  
printf ("            Length: %.2f seconds\n",
		   mp3info.time_seconds);
	  
printf ("            Frames: %d\n", mp3info.total_frames);
	  
for (a = 0; a < 19; a++) {
	    
if (mp3info.amnt_bitrates[a]) {
	      
last = a;
	      
if (first < 0)
		
first = a;
	    
}
	  
}
	  
if (first >= 0 && last >= 0) {
	    
for (a = first; a <= last; a++) {
	      
printf ("  %18s: %4.1f%% (%d frames)\n", kbit_array[a], 
		       (100.0f * mp3info.amnt_bitrates[a] /
			mp3info.total_frames), 
mp3info.amnt_bitrates[a]);
	    
}
	  
}
	  

printf ("\n");
	  
delete[]mp3info.bitrates;
	
}
      
}
    
}
    
return 0;
  
} else {
    
usage ();
    
return 0;
  
}

}
