#include <gtk/gtk.h>
#include <string>
#include "gtkGui.h"

/* Global variables are bad */
extern GdkColor     color_array[19];

static gboolean
closed (GtkWidget * widget, GdkEvent *event, Info * chosen1)
{
  chosen1->zz = 0;
  return FALSE;
}

void
detailed_info (GtkWidget * dummy, GdkEventButton * event, Info * chosen1)
{
  GtkWidget          *window = NULL;
  GtkWidget          *lgraph = NULL;
  GdkRectangle        rect;
  GdkGC              *lgc = NULL;
  GdkPixmap          *pixmap = NULL;
  float               x = 0;
  int                 avg = 0, y = 0, zy = 0, zz = 0;
  float               divisor = 0;

  if (chosen1->selected_oldfile == NULL || chosen1->zz != 0) {
    return;
  }
  chosen1->zz = 1;
  divisor = (float) chosen1->mp3infoa->total_frames / 800;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), chosen1->selected_oldfile);
  gtk_window_set_resizable (GTK_WINDOW (window), FALSE);

  lgraph = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (lgraph), 800, 300);

  gtk_container_border_width (GTK_CONTAINER (window), 10);
  gtk_container_add (GTK_CONTAINER (window), lgraph);
  gtk_widget_show (lgraph);
  gtk_widget_show (window);

  lgc = gdk_gc_new (lgraph->window);
  gdk_gc_set_fill (lgc, GDK_SOLID);
  
  pixmap = gdk_pixmap_new (lgraph->window, 800, 300, -1);

  gdk_draw_rectangle (pixmap, lgraph->style->light_gc[0],
		      TRUE, 0, 0, 800, 300);
  gdk_draw_pixmap (lgraph->window, lgraph->style->white_gc, pixmap,
		   0, 0, 0, 0, 800, 300);
  gdk_gc_set_foreground (lgc, &color_array[0]);
  rect.x = 0;
  rect.y = 0;
  rect.height = 300;
  rect.width = 800;

  for (int h = 0; h < 19; h++) {
    gdk_draw_line (pixmap, lgraph->style->black_gc, 0, h * 15, 800,
		   h * 15);
  }

  for (x = 0; x < chosen1->mp3infoa->total_frames; x += divisor) {
    for (y = (int) x;
	 (y < (x + divisor)) && (y < chosen1->mp3infoa->total_frames); y++) {
      avg += place (chosen1->mp3infoa->bitrates[y]);
      zy++;
    }
    avg /= zy;
    zy = 0;
    gdk_gc_set_foreground (lgc, &color_array[avg]);
    if (zz < 800) {
      gdk_draw_rectangle (pixmap,
			  lgc, TRUE, zz, 300 - (avg * 15), 1, avg * 15);

      gdk_draw_pixmap (lgraph->window,
		       lgc,
		       pixmap,
		       zz, 300 - (avg * 15), zz, 300 - (avg * 15),
		       1, avg * 15);
    }
    avg = 0;
    zz++;
  }

  g_signal_connect (GTK_OBJECT (lgraph), "configure_event",
		    G_CALLBACK (configure_event), pixmap);
  g_signal_connect (GTK_OBJECT (lgraph), "expose_event",
		    G_CALLBACK (expose_event), pixmap);
  g_signal_connect_after (GTK_OBJECT (window), "delete_event",
                   G_CALLBACK (closed), chosen1);
  g_signal_connect_swapped (GTK_OBJECT (window), "destroy",
			    G_CALLBACK (gtk_widget_destroy), window);

  gtk_widget_queue_draw (lgraph);
}
